//----------------------------------------------------------------------------
// name: main.cpp
// desc: bokeh entry point
//
// author: Ge Wang (ge@ccrma.stanford.edu)
// date: fall 2013
//----------------------------------------------------------------------------
#include <iostream>
#include "bk-audio.h"
#include "bk-gfx.h"
#include "bk-globals.h"
using namespace std;




//----------------------------------------------------------------------------
// name: main()
// desc: application entry point
//----------------------------------------------------------------------------
int main( int argc, const char ** argv )
{
    system( "pwd" );
    // invoke graphics setup and loop
    if( !bk_gfx_init( argc, argv ) )
    {
        // error message
        cerr << "[bokeh]: cannot initialize graphics/data system..." << endl;
        return -1;
    }
    
    // start real-time audio
    if( !bk_audio_init( BK_SRATE, BK_FRAMESIZE, BK_NUMCHANNELS ) )
    {
        // error message
        cerr << "[bokeh]: cannot initialize real-time audio I/O..." << endl;
        return -1;
    }
    
    // start audio
    if( !bk_audio_start() )
    {
        // error message
        cerr << "[bokeh]: cannot start real-time audio I/O..." << endl;
        return -1;
    }
    
    // graphics loop
    bk_gfx_loop();
    
    return 0;
}
